package com.fp.persistence.pgeneral.safe;

import java.sql.Timestamp;
import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import com.fp.dto.hb.History;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TSAFEUSERSESSION*/
@Embeddable
public class TsafeUserSessionKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId,History{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="USERCODE", nullable=false,updatable=false)

/**
* Codigo de usuario
*/
private String usercode;

@Column(name="DATETO", nullable=false,updatable=false)

/**
* Fecha hasta la cual esta vigente el registro.
*/
private Timestamp dateto;

/**Contructor por defecto*/
public TsafeUserSessionKey(){}
/**Contructor de TsafeUserSessionKey
@param pUsercode Codigo de usuario
@param pDateto Fecha hasta la cual esta vigente el registro.
*/
public TsafeUserSessionKey(String pUsercode,Timestamp pDateto){
 usercode=pUsercode;
 dateto=pDateto;
}
/**Obtiene el valor de usercode
@return valor de usercode*/
public String getUsercode(){
  return usercode;
}
/**Fija el valor de usercode
@param pUsercode nuevo Valor de usercode*/
public void setUsercode(String pUsercode){
  usercode=pUsercode;
}

/**Obtiene el valor de dateto
@return valor de dateto*/
public Timestamp getDateto(){
  return dateto;
}
/**Fija el valor de dateto
@param pDateto nuevo Valor de dateto*/
public void setDateto(Timestamp pDateto){
  dateto=pDateto;
}

/**Implementación de la comparación de TsafeUserSessionKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TsafeUserSessionKey))return false;
  TsafeUserSessionKey that = (TsafeUserSessionKey) o;
  if (this.getUsercode() == null || that.getUsercode() == null){
      return false;
  }
  if (! this.getUsercode().equals(that.getUsercode())){
    return false;
  }
  if (this.getDateto() == null || that.getDateto() == null){
      return false;
  }
  if (! this.getDateto().equals(that.getDateto())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TsafeUserSessionKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getUsercode() == null ? 0 : this.getUsercode().hashCode());
    result = result * 37 + (this.getDateto() == null ? 0 : this.getDateto().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
public Object getId() {
  return null;
}
}
